import { readdir as q, readFile as B, writeFile as N } from "fs/promises";
import { existsSync as C, mkdirSync as V } from "fs";
import { normalize as j, join as k, extname as F } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function K(t, e = 0) {
  const i = [], f = [], p = [];
  let y = "", u = e;
  const d = (a) => (e = u, { type: a, value: b(), position: { start: e, end: u } }), x = (a) => {
    a.value = b(), a.position.start = e, a.position.end = u;
  }, $ = () => t[++u], A = () => u < t.length - 1 ? t[u + 1] : "", S = () => u > 0 ? t[u - 1] : "", b = () => t.substring(e, u + 1), P = (a) => /["'`0-9+-]/.test(a), w = (a) => /[a-zA-Z_$]/.test(a), v = (a) => /[(){},:;.[\]?!=<>]/.test(a), g = (a) => /\//.test(a) && /\*/.test(A()), n = (a, c) => {
    if (!c)
      c = d("Literal"), i.push(c);
    else {
      if (p.length === 0 && !/[0-9.]/.test(a))
        return l(a);
      x(c);
    }
    return p.length === 0 && /["'`]/.test(a) ? p.push(a) : p.length > 0 && p[p.length - 1] === a && (/\\/.test(S()) || p.pop()), n($(), c);
  }, s = (a, c) => {
    if (!c)
      y = a, c = d("Identifier"), i.push(c);
    else if (/[0-9a-zA-Z_$. ]/.test(a))
      y += a, (y == "null" || y == "undefined" || y == "true" || y == "false" || y == "void 0") && (c.type = "Literal"), x(c);
    else
      return l(a);
    return s($(), c);
  }, r = (a, c) => (c = d("Punctuator"), i.push(c), /\(/.test(a) ? f.push(a) : /\)/.test(a) && f.pop(), l($())), o = (a) => /\//.test(a) && /\*/.test(S()) ? l(a) : o($()), m = () => i[i.length - 1]?.type === "Punctuator" && f.length === 0 || u === t.length, l = (a = t[u]) => m() ? i : P(a) ? n(a) : w(a) ? s(a) : v(a) ? r(a) : g(a) ? o(a) : l($());
  return l();
}
function M(t, e, i) {
  let f, p = 0;
  const y = [], u = () => p < t.length - 1 ? t[p + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, d = () => t[++p], x = () => t[t.length - 1], $ = (s) => s.replace(/^["'`]|["'`]$/g, ""), A = (s) => (f.arguments.push({ type: "Literal", value: $(s.value) }), g(d())), S = (s) => (f.arguments.push({ type: "Identifier", value: s.value }), g(d())), b = (s, r, o) => (o || (o = {
    type: "Property",
    key: { type: "Identifier", value: s.value },
    value: { type: "Literal", value: "" }
  }, r.push(o)), !/^:$/.test(s.value) && !/^:$/.test(u().value) ? s.type === "Literal" ? (o.value.value = $(s.value), w(d(), r)) : (o.value.type = "Expression", P(s, r, o)) : b(d(), r, o)), P = (s, r, o) => (o.value.value += s.value, /^[({]$/.test(s.value) ? y.push(s.value) : /^[)}]$/.test(s.value) && y.pop(), /^[,}]$/.test(u().value) && y.length === 0 ? w(d(), r) : P(d(), r, o)), w = (s, r) => (r || (r = [], f.arguments.push({ type: "ObjectExpression", properties: r })), /^}$/.test(s.value) ? g(d()) : /^:$/.test(u().value) ? b(s, r) : w(d(), r)), v = (s, r) => (r || (r = [], f.arguments.push({ type: "ArrayExpression", elements: r })), /^]$/.test(s.value) ? g(d()) : (s.type === "Literal" && r.push({ type: "Literal", value: $(s.value) }), s.type === "Identifier" && r.push({ type: "Identifier", value: s.value }), v(d(), r))), g = (s) => Object.is(s, x()) ? f : s.type === "Literal" ? A(s) : s.type === "Identifier" && /^\($/.test(u().value) ? n(s) : s.type === "Identifier" ? S(s) : /^{$/.test(s.value) ? w(s) : /^\[$/.test(s.value) ? v(s) : g(d()), n = (s, r, o = s.position.start) => r ? /^\)$/.test(s.value) ? (r.value = e.substring(o, s.position.end + 1), g(d())) : n(d(), r, o) : new RegExp(i).test(s.value) ? (f = {
    type: "CallExpression",
    value: e.substring(o, x().position.end + 1),
    arguments: []
  }, g(d())) : (r = { type: "CallExpression", value: "" }, f.arguments.push(r), n(d(), r, o));
  return n(t[p]);
}
function W(t, e) {
  const i = new RegExp(`${e}\\(`, "gs"), f = [];
  let p;
  for (; (p = i.exec(t)) !== null; )
    f.push(p.index);
  return f;
}
function I(t, e) {
  const i = [], f = W(t, e);
  for (const p of f) {
    const y = K(t, p);
    if (y.length > 0)
      try {
        const u = M(y, t, e);
        u && i.push(u);
      } catch (u) {
        console.error(u), console.error(
          `\x1B[31m
Qwik Speak Inline error parsing \x1B[0m %s`,
          t.substring(p, y[y.length - 1].position.end) + `
`
        );
      }
  }
  return i;
}
function Q(t) {
  let e = t.match(/(?<=\bconst\s).*?(?=\s?=\s?useTranslate\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function U(t) {
  let e = t.match(/(?<=inlineTranslate\s+as).*?(?=,|\})/s)?.[0]?.trim() || "inlineTranslate";
  return e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e;
}
function Z(t) {
  let e = t.match(/(?<=\bconst\s).*?(?=\s?=\s?usePlural\(\);?)/)?.[0]?.trim();
  return e ? (e.startsWith("$") || (e = `\\b${e}`), e = e.replace(/\$/g, "\\$"), e) : null;
}
function _(t) {
  return JSON.parse(t, (e, i) => i === null || i === "" ? void 0 : i);
}
function G(t, e, i) {
  let f = 0;
  const p = e.length;
  for (; f < p; ) {
    const y = e[f++];
    t[y] = f === p ? i : typeof t[y] == "object" ? t[y] : {}, t = t[y];
  }
}
function J(t, e) {
  return typeof t == "object" && typeof e == "object" ? (Object.keys(e).map((i) => {
    t[i] = J(t[i], e[i]);
  }), t) : e;
}
function H(t) {
  return typeof t == "object" ? JSON.parse(JSON.stringify(t)) : t;
}
function X(t, e) {
  return t = { ...t, ...e }, t;
}
function Y(t) {
  return JSON.stringify(t, ee, 2);
}
function T(t) {
  return typeof t == "object" && Object.keys(t).length > 0 ? 1 + Math.min(1, ...Object.values(t).map((e) => T(e))) : 0;
}
function R(t) {
  return Object.keys(t).sort().reduce(
    (e, i) => (typeof t[i] == "object" && !Array.isArray(t[i]) ? e[i] = R(t[i]) : e[i] = t[i], e),
    {}
  );
}
function ee(t, e) {
  return typeof e == "string" ? e.replace(/\\/g, "") : e;
}
function te(t, e) {
  const i = /* @__PURE__ */ new Set();
  for (let f = 0; f < 20; f++) {
    const p = new Intl.PluralRules(t, e).select(f);
    i.add(p);
  }
  return Array.from(i);
}
function se(t) {
  let e;
  if (t) {
    e = {};
    for (const i of t)
      e = { ...e, [i.key.value]: i.value.value };
  }
  return e;
}
async function ie(t) {
  const e = {
    ...t,
    basePath: t.basePath ?? "./",
    sourceFilesPaths: t.sourceFilesPaths ?? ["src"],
    excludedPaths: t.excludedPaths ?? [],
    assetsPath: t.assetsPath ?? "i18n",
    format: t.format ?? "json",
    filename: t.filename ?? "app",
    keySeparator: t.keySeparator ?? ".",
    keyValueSeparator: t.keyValueSeparator ?? "@@"
  }, i = /* @__PURE__ */ new Map(), f = e.sourceFilesPaths.map((n) => j(`${e.basePath}/${n}`)), p = e.excludedPaths.map((n) => j(`${e.basePath}/${n}`)), y = [], u = Object.fromEntries(e.supportedLangs.map((n) => [n, {}])), d = async (n, s) => {
    const r = await q(n, { withFileTypes: !0 });
    for (const o of r) {
      const m = k(n, o.name), l = F(o.name);
      o.isDirectory() ? s.includes(m) || await d(m, s) : /\.js|\.ts|\.jsx|\.tsx/.test(l) && !/test|spec/.test(o.name) && y.push(m);
    }
  }, x = (n) => n.type === "Identifier" || n.type === "Literal" && n.value && /\${.*}/.test(n.value) ? (i.set("dynamic", (i.get("dynamic") ?? 0) + 1), !0) : !1, $ = async (n) => {
    const s = [];
    let r = await B(j(`${e.basePath}/${n}`), "utf8");
    const o = (l) => {
      r = r.replace(new RegExp(`${l}<.*>\\(`, "g"), `${l.replace("\\b", "")}(`);
    }, m = (l) => {
      for (const a of l) {
        const c = a.arguments;
        if (c?.length > 0) {
          if (c[0].type === "ArrayExpression") {
            if (c[0].elements) {
              for (const h of c[0].elements)
                if (h.type === "Literal") {
                  if (x(h))
                    continue;
                  s.push(h.value);
                }
            }
          } else if (c?.[0]?.value) {
            if (x(c[0]))
              continue;
            s.push(c[0].value);
          }
        }
      }
    };
    if (/useTranslate/.test(r)) {
      const l = Q(r);
      if (l) {
        o(l);
        const a = I(r, l);
        m(a);
      }
    }
    if (/inlineTranslate/.test(r)) {
      const l = U(r);
      o(l);
      const a = I(r, l);
      m(a);
    }
    if (/usePlural/.test(r)) {
      const l = Z(r);
      if (l) {
        const a = I(r, l);
        for (const c of a) {
          const h = c.arguments;
          if (h?.length > 0) {
            if (h[1]?.type === "Identifier" || h[1]?.type === "CallExpression" || h[3]?.type === "Identifier" || h[3]?.type === "CallExpression") {
              i.set("dynamic plural", (i.get("dynamic plural") ?? 0) + 1);
              continue;
            }
            const E = /* @__PURE__ */ new Set(), z = se(h[3]?.properties);
            for (const O of e.supportedLangs) {
              const L = te(O, z);
              for (const D of L)
                E.add(D);
            }
            for (const O of E) {
              let L = h?.[1]?.value;
              L = L ? `${L}${e.keySeparator}${O}` : O, s.push(L);
            }
          }
        }
      }
    }
    return s;
  }, A = async () => {
    const n = /* @__PURE__ */ new Map();
    for (const s of e.supportedLangs) {
      const r = j(`${e.basePath}/${e.assetsPath}/${s}`);
      if (C(r)) {
        const o = await q(r);
        if (o.length > 0) {
          const m = F(o[0]);
          let l = {};
          const a = o.map((h) => B(`${r}/${h}`, "utf8")), c = await Promise.all(a);
          for (const h of c)
            if (h) {
              let E = {};
              switch (m) {
                case ".json":
                  E = _(h);
                  break;
              }
              l = X(l, E);
            }
          n.set(s, l);
        }
      }
    }
    return n;
  }, S = async () => {
    for (const n of e.supportedLangs) {
      const s = j(`${e.basePath}/${e.assetsPath}/${n}`);
      C(s) || V(s, { recursive: !0 });
      const r = Object.keys(u[n]).filter((l) => T(u[n][l]) > 0), o = Object.keys(u[n]).filter((l) => T(u[n][l]) === 0), m = {};
      u[n][e.filename] && (m[e.filename] = u[n][e.filename]);
      for (const l of o)
        m[l] = u[n][l];
      Object.keys(m).length > 0 && await b(m, e.filename, s);
      for (const l of r.filter((a) => a !== e.filename))
        await b({ [l]: u[n][l] }, l, s);
    }
  }, b = async (n, s, r) => {
    let o;
    switch (e.format) {
      case "json":
        o = Y(n);
        break;
    }
    const m = j(`${r}/${s}.${e.format}`);
    await N(m, o), console.log(m);
  };
  for (const n of f)
    await d(n, p);
  const P = y.map((n) => $(n)), w = await Promise.all(P);
  let v = [];
  for (const n of w)
    v = v.concat(n);
  v = [...new Set(v)], i.set("unique keys", (i.get("unique keys") ?? 0) + v.length);
  for (let n of v) {
    let s;
    [n, s] = n.split(e.keyValueSeparator), /^[[{].*[\]}]$/.test(s) && !/^{{/.test(s) && (s = JSON.parse(s));
    for (const r of e.supportedLangs)
      G(u[r], n.split(e.keySeparator), H(s || ""));
  }
  const g = await A();
  if (g.size > 0)
    for (const [n, s] of g)
      J(u[n], s);
  for (const n of e.supportedLangs)
    u[n] = R(u[n]);
  await S();
  for (const [n, s] of i)
    switch (n) {
      case "unique keys":
        console.log("\x1B[32m%s\x1B[0m", `extracted keys: ${s}`);
        break;
      case "dynamic":
        console.log("\x1B[32m%s\x1B[0m", `translations skipped due to dynamic keys: ${s}`);
        break;
      case "dynamic plural":
        console.log("\x1B[32m%s\x1B[0m", `plurals skipped due to dynamic keys/options: ${s}`);
        break;
    }
}
export {
  ie as qwikSpeakExtract
};
