import { readdir as z, readFile as K, writeFile as R } from "fs/promises";
import { createWriteStream as J, existsSync as U, mkdirSync as Z } from "fs";
import { normalize as E, extname as G } from "path";
/**
 * @license
 * Qwik Speak
 * Use of this source code is governed by an MIT-style license that can be
 * found in the LICENSE file at https://github.com/robisim74/qwik-speak/blob/main/LICENSE
 */
function T(e, t = 0) {
  const r = [], i = [], s = [];
  let a = "", n = t;
  const l = (o) => (t = n, { type: o, value: h(), position: { start: t, end: n } }), c = (o) => {
    o.value = h(), o.position.start = t, o.position.end = n;
  }, f = () => e[++n], y = () => n < e.length - 1 ? e[n + 1] : "", $ = () => n > 0 ? e[n - 1] : "", h = () => e.substring(t, n + 1), m = (o) => /["'`0-9+-]/.test(o), v = (o) => /[a-zA-Z_$]/.test(o), w = (o) => /[(){},:;.[\]?!=<>]/.test(o), b = (o) => /\//.test(o) && /\*/.test(y()), I = (o, d) => {
    if (!d)
      d = l("Literal"), r.push(d);
    else {
      if (s.length === 0 && !/[0-9.]/.test(o))
        return k(o);
      c(d);
    }
    return s.length === 0 && /["'`]/.test(o) ? s.push(o) : s.length > 0 && s[s.length - 1] === o && (/\\/.test($()) || s.pop()), I(f(), d);
  }, u = (o, d) => {
    if (!d)
      a = o, d = l("Identifier"), r.push(d);
    else if (/[0-9a-zA-Z_$. ]/.test(o))
      a += o, (a == "null" || a == "undefined" || a == "true" || a == "false" || a == "void 0") && (d.type = "Literal"), c(d);
    else
      return k(o);
    return u(f(), d);
  }, p = (o, d) => (d = l("Punctuator"), r.push(d), /\(/.test(o) ? i.push(o) : /\)/.test(o) && i.pop(), k(f())), g = (o) => /\//.test(o) && /\*/.test($()) ? k(o) : g(f()), W = () => r[r.length - 1]?.type === "Punctuator" && i.length === 0 || n === e.length, k = (o = e[n]) => W() ? r : m(o) ? I(o) : v(o) ? u(o) : w(o) ? p(o) : b(o) ? g(o) : k(f());
  return k();
}
function D(e, t, r) {
  let i, s = 0;
  const a = [], n = () => s < e.length - 1 ? e[s + 1] : { type: "", value: "", position: { start: 0, end: 0 } }, l = () => e[++s], c = () => e[e.length - 1], f = (u) => u.replace(/^["'`]|["'`]$/g, ""), y = (u) => (i.arguments.push({ type: "Literal", value: f(u.value) }), b(l())), $ = (u) => (i.arguments.push({ type: "Identifier", value: u.value }), b(l())), h = (u, p, g) => (g || (g = {
    type: "Property",
    key: { type: "Identifier", value: u.value },
    value: { type: "Literal", value: "" }
  }, p.push(g)), !/^:$/.test(u.value) && !/^:$/.test(n().value) ? u.type === "Literal" ? (g.value.value = f(u.value), v(l(), p)) : (g.value.type = "Expression", m(u, p, g)) : h(l(), p, g)), m = (u, p, g) => (g.value.value += u.value, /^[({]$/.test(u.value) ? a.push(u.value) : /^[)}]$/.test(u.value) && a.pop(), /^[,}]$/.test(n().value) && a.length === 0 ? v(l(), p) : m(l(), p, g)), v = (u, p) => (p || (p = [], i.arguments.push({ type: "ObjectExpression", properties: p })), /^}$/.test(u.value) ? b(l()) : /^:$/.test(n().value) ? h(u, p) : v(l(), p)), w = (u, p) => (p || (p = [], i.arguments.push({ type: "ArrayExpression", elements: p })), /^]$/.test(u.value) ? b(l()) : (u.type === "Literal" && p.push({ type: "Literal", value: f(u.value) }), u.type === "Identifier" && p.push({ type: "Identifier", value: u.value }), w(l(), p))), b = (u) => Object.is(u, c()) ? i : u.type === "Literal" ? y(u) : u.type === "Identifier" && /^\($/.test(n().value) ? I(u) : u.type === "Identifier" ? $(u) : /^{$/.test(u.value) ? v(u) : /^\[$/.test(u.value) ? w(u) : b(l()), I = (u, p, g = u.position.start) => p ? /^\)$/.test(u.value) ? (p.value = t.substring(g, u.position.end + 1), b(l())) : I(l(), p, g) : new RegExp(r).test(u.value) ? (i = {
    type: "CallExpression",
    value: t.substring(g, c().position.end + 1),
    arguments: []
  }, b(l())) : (p = { type: "CallExpression", value: "" }, i.arguments.push(p), I(l(), p, g));
  return I(e[s]);
}
function H(e, t) {
  const r = new RegExp(`${t}\\(`, "gs"), i = [];
  let s;
  for (; (s = r.exec(e)) !== null; )
    i.push(s.index);
  return i;
}
function A(e, t) {
  const r = [], i = H(e, t);
  for (const s of i) {
    const a = T(e, s);
    if (a.length > 0)
      try {
        const n = D(a, e, t);
        n && r.push(n);
      } catch (n) {
        console.error(n), console.error(
          `\x1B[31m
Qwik Speak Inline error parsing \x1B[0m %s`,
          e.substring(s, a[a.length - 1].position.end) + `
`
        );
      }
  }
  return r;
}
function X(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?useTranslate\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function Y(e) {
  let t = e.match(/(?<=inlineTranslate\s+as).*?(?=,|\})/s)?.[0]?.trim() || "inlineTranslate";
  return t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t;
}
function ee(e) {
  let t = e.match(/(?<=\bconst\s).*?(?=\s?=\s?usePlural\(\);?)/)?.[0]?.trim();
  return t ? (t.startsWith("$") || (t = `\\b${t}`), t = t.replace(/\$/g, "\\$"), t) : null;
}
function te(e) {
  return JSON.parse(e, (t, r) => r === null || r === "" ? void 0 : r);
}
function ne(e, t) {
  const r = /* @__PURE__ */ new Set();
  for (let i = 0; i < 20; i++) {
    const s = new Intl.PluralRules(e, t).select(i);
    r.add(s);
  }
  return Array.from(r);
}
function se(e) {
  let t;
  if (e) {
    t = {};
    for (const r of e)
      t = { ...t, [r.key.value]: r.value.value };
  }
  return t;
}
function re(e, t) {
  return e = { ...e, ...t }, e;
}
const P = "__qsInline", j = "__qsInlineTranslate", O = "__qsInlinePlural", ie = "\\b_fnSignal", q = [], S = [], L = [];
function Ie(e) {
  const t = {
    ...e,
    basePath: e.basePath ?? "./",
    assetsPath: e.assetsPath ?? "i18n",
    outDir: e.outDir ?? "dist",
    keySeparator: e.keySeparator ?? ".",
    keyValueSeparator: e.keyValueSeparator ?? "@@"
  }, r = Object.fromEntries(t.supportedLangs.map((n) => [n, {}]));
  let i, s;
  return {
    name: "vite-plugin-qwik-speak-inline",
    enforce: "post",
    // Apply only on build
    apply: "build",
    configResolved(n) {
      i = n.build?.ssr || n.mode === "ssr" ? "ssr" : "client";
      const l = n.build?.rollupOptions?.input;
      l && (Array.isArray(l) ? s = l[0] : typeof l == "string" && (s = l)), s = s?.split("/")?.pop();
    },
    /**
     * Load translation files when build starts
     */
    async buildStart() {
      i === "client" && await Promise.all(t.supportedLangs.map(async (n) => {
        const l = E(`${t.basePath}/${t.assetsPath}/${n}`), c = await z(l);
        if (c.length > 0) {
          const f = G(c[0]);
          let y = {};
          const $ = c.map((m) => K(`${l}/${m}`, "utf8")), h = await Promise.all($);
          for (const m of h)
            if (m) {
              let v = {};
              switch (f) {
                case ".json":
                  v = te(m);
                  break;
              }
              y = re(y, v);
            }
          r[n] = { ...r[n], ...y };
        }
      }));
    },
    /**
     * Transform functions
     * Prefer transform hook because unused imports will be removed, unlike renderChunk
     */
    async transform(n, l) {
      if (i === "client" && /\/src\//.test(l) && /\.(js|cjs|mjs|jsx|ts|tsx)$/.test(l))
        return /usePlural/.test(n) && (n = fe(n)), /useTranslate/.test(n) && (n = ae(n)), /inlineTranslate/.test(n) && (n = ue(n)), n;
      i === "ssr" && l.endsWith("entry.ssr.tsx") && (/(?<!\/\/\s*)base:\s*extractBase/.test(n) || (console.log(
        `
\x1B[31mQwik Speak Inline error\x1B[0m
%s`,
        "Missing 'base' option in 'entry.ssr.tsx' file: see https://robisim74.gitbook.io/qwik-speak/tools/inline#usage"
      ), process.exit(1)));
    },
    /**
     * Split chunks by lang
     */
    async writeBundle(n, l) {
      if (i === "client") {
        const c = n.dir ? n.dir : E(`${t.basePath}/${t.outDir}`), f = Object.values(l), y = t.supportedLangs.map(($) => le($, f, c, r, t));
        await Promise.all(y);
      }
    },
    async closeBundle() {
      if (i === "client") {
        const n = J("./qwik-speak-inline.log", { flags: "w" });
        n.write(`${i}: ` + (s ?? "-") + `
`), q.forEach((l) => n.write(l + `
`)), S.forEach((l) => n.write(l + `
`)), L.forEach((l) => n.write(l + `
`)), n.write(`Qwik Speak Inline: build ends at ${(/* @__PURE__ */ new Date()).toLocaleString()}
`), (q.length > 0 || S.length > 0 || L.length > 0) && console.log(
          `
\x1B[33mQwik Speak Inline warn\x1B[0m
%s`,
          "There are missing values or dynamic keys: see ./qwik-speak-inline.log"
        );
      }
    }
  };
}
async function le(e, t, r, i, s) {
  const a = E(`${r}/build/${e}`);
  U(a) || Z(a, { recursive: !0 });
  for (const n of t) {
    const l = [];
    if (n.type === "chunk" && "code" in n && /build\//.test(n.fileName)) {
      const c = E(`${a}/${n.fileName.split("/")[1]}`);
      let f = n.code;
      if (f.includes(O) && (f = oe(f, O, P, e, s)), f.includes(P) && (f = _(f, i, P, e, s)), f.includes(j) && (f = _(f, i, j, e, s)), l.push(R(c, f)), e === s.defaultLang) {
        const y = E(`${r}/build`), $ = E(`${y}/${n.fileName.split("/")[1]}`);
        l.push(R($, f));
      }
    }
    await Promise.all(l);
  }
}
function ae(e) {
  const t = X(e);
  if (t) {
    const i = A(e, t);
    if (i.length === 0)
      return e;
    for (const s of i) {
      const a = s.value, n = s.arguments;
      if (n?.length > 0) {
        if (V(n, a))
          continue;
        const l = a.replace(new RegExp(`${t}\\(`), `${P}(`);
        e = e.replace(a, l);
      }
    }
  }
  const r = A(e, ie);
  if (r.length === 0)
    return e;
  for (const i of r) {
    const s = i.arguments;
    if (s?.length > 2 && s[s.length - 1].type === "ArrayExpression") {
      const a = s[s.length - 1].elements;
      if (a && a.find((n) => new RegExp(`^${t}$`).test(n.value))) {
        const n = a.findIndex((l) => new RegExp(`^${t}$`).test(l.value));
        if (s[n].type === "Identifier" && s[s.length - 2].type === "CallExpression") {
          const l = s[s.length - 2].value;
          if (l && s[n].value) {
            const c = `\\b${s[n].value}`, f = T(l), y = D(f, l, c);
            if (y) {
              const $ = y.arguments;
              if ($?.length > 0) {
                if (V($, l))
                  continue;
                const h = l.replace(new RegExp(`${c}\\(`), `${P}(`);
                e = e.replace(l, h);
              }
            }
          }
        }
      }
    }
  }
  return e;
}
function ue(e) {
  const t = Y(e), r = A(e, t);
  if (r.length === 0)
    return e;
  for (const i of r) {
    const s = i.value, a = i.arguments;
    if (a?.length > 0) {
      if (ye(a, s))
        continue;
      const n = s.replace(new RegExp(`${t}\\(`), `${j}(`);
      e = e.replace(s, n);
    }
  }
  return e;
}
function fe(e) {
  const t = ee(e);
  if (t) {
    const r = A(e, t);
    if (r.length === 0)
      return e;
    for (const i of r) {
      const s = i.value, a = i.arguments;
      if (a?.length > 0) {
        if (me(a, s))
          continue;
        const n = s.replace(new RegExp(`${t}\\(`), `${O}(`);
        e = e.replace(s, n);
      }
    }
  }
  return e;
}
function _(e, t, r, i, s) {
  const a = A(e, r);
  if (a.length === 0)
    return e;
  for (const n of a) {
    const l = n.value, c = n.arguments;
    if (c?.length > 0) {
      const f = M(i, r === P ? c[2] : c[3], s);
      let y = x("");
      if (c[0].type === "ArrayExpression") {
        const h = he(c[0], s.keyValueSeparator), m = [];
        for (const { key: v, defaultValue: w } of h) {
          const b = B(
            v,
            t[f],
            r === P ? c[1] : c[2],
            s.keySeparator
          );
          b ? m.push(b) : (q.push(`${f} - missing value for key: ${v}`), w ? m.push(x(w)) : m.push(x("")));
        }
        y = m;
      } else if (c?.[0]?.value) {
        const { key: h, defaultValue: m } = $e(c[0].value, s.keyValueSeparator), v = B(
          h,
          t[f],
          r === P ? c[1] : c[2],
          s.keySeparator
        );
        v ? y = v : (q.push(`${f} - missing value for key: ${h}`), m && (y = x(m)));
      }
      const $ = ce(y);
      e = e.replace(l, $);
    }
  }
  return e;
}
function oe(e, t, r, i, s) {
  const a = A(e, t);
  if (a.length === 0)
    return e;
  for (const n of a) {
    const l = n.value, c = n.arguments;
    if (c?.length > 0) {
      const f = M(i, c[4], s), y = se(c[3]?.properties), $ = ne(f, y), h = pe($, f, r, c, s);
      e = e.replace(l, h);
    }
  }
  return e;
}
function ce(e) {
  return typeof e == "object" ? `${de(e)}` : e;
}
function pe(e, t, r, i, s) {
  let a = "";
  return a += ((l) => {
    let c = "(";
    for (const f of e) {
      let y = i[1]?.value;
      y = y ? `${y}${s.keySeparator}${f}` : f;
      const $ = [{
        type: "Property",
        key: { type: "Identifier", value: "value" },
        value: { type: "Expression", value: i[0].value }
      }];
      if (i[2]?.properties)
        for (const m of i[2].properties)
          $.push(m);
      const h = $.map((m) => `${m.key.value}: ${C(m)}`).join(", ");
      if (f !== e[e.length - 1]) {
        const m = i[3]?.properties?.map((w) => `${w.key.value}: ${C(w)}`)?.join(", "), v = ve(l, i[0].value, f, m);
        c += v + ` && ${r}(${x(y)}, {${h}}, ${x(l)}) || `;
      } else
        c += `${r}(${x(y)}, {${h}}, ${x(l)})`;
    }
    return c += ")", c;
  })(t), a;
}
function V(e, t) {
  if (e?.[0]?.value) {
    if (e[0].type === "Identifier")
      return S.push(
        `dynamic key: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
      ), !0;
    if (e[0].type === "Literal" && /\${.*}/.test(e[0].value))
      return S.push(
        `dynamic key: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
      ), !0;
    if (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression")
      return L.push(
        `dynamic params: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
      ), !0;
  }
  return !1;
}
function ye(e, t) {
  if (e?.[0]?.value) {
    if (e[0].type === "Identifier")
      return S.push(
        `dynamic key: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
      ), !0;
    if (e[0].type === "Literal" && /\${.*}/.test(e[0].value))
      return S.push(
        `dynamic key: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
      ), !0;
    if (e[2]?.type === "Identifier" || e[2]?.type === "CallExpression" || e[3]?.type === "Identifier" || e[3]?.type === "CallExpression")
      return L.push(
        `
      dynamic params: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
      ), !0;
  }
  return !1;
}
function me(e, t) {
  return e?.[0]?.value && (e[1]?.type === "Identifier" || e[1]?.type === "CallExpression" || e[2]?.type === "Identifier" || e[2]?.type === "CallExpression" || e[3]?.type === "Identifier" || e[3]?.type === "CallExpression" || e[4]?.type === "Identifier" || e[4]?.type === "CallExpression") ? (L.push(
    `dynamic plural: ${t.replace(/\s+/g, " ")} - Make sure the keys are in 'runtimeAssets'`
  ), !0) : !1;
}
function M(e, t, r) {
  let i;
  return t?.type === "Literal" && (i = r.supportedLangs.find((s) => s === t.value)), i ?? e;
}
function $e(e, t) {
  let r;
  return [e, r] = F(e, t), { key: e, defaultValue: r };
}
function he(e, t) {
  const r = [];
  if (e.elements) {
    for (const i of e.elements)
      if (i.type === "Literal") {
        let s, a;
        [s, a] = F(i.value, t), r.push({ key: s, defaultValue: a });
      }
  }
  return r;
}
const F = (e, t) => e.split(t);
function B(e, t, r, i) {
  const s = e.split(i).reduce((a, n) => a && a[n] !== void 0 ? a[n] : void 0, t);
  if (s) {
    if (typeof s == "string")
      return r ? Q(s, r) : x(s);
    if (typeof s == "object")
      return r ? N(s, r) : s;
  }
}
function N(e, t) {
  return Object.keys(e).map((r) => {
    typeof e[r] == "string" && (e[r] = t ? Q(e[r], t) : x(e[r])), e[r] && typeof e[r] == "object" && (e[r] = N(e[r], t));
  }), e;
}
function Q(e, t) {
  if (t.properties)
    for (const r of t.properties)
      e = e.replace(/{{\s?([^{}\s]*)\s?}}/g, (i, s) => s === r.key.value ? ge(r) : i);
  return x(e);
}
function x(e) {
  return /^`.*`$/.test(e) ? e : "`" + e + "`";
}
function ge(e) {
  return e.value.type === "Literal" ? e.value.value : "${" + e.value.value + "}";
}
function C(e) {
  return e.value.type === "Literal" ? x(e.value.value) : e.value.value;
}
function ve(e, t, r, i) {
  return i ? `new Intl.PluralRules(${x(e)}, {${i}}).select(+${t}) === ${x(r)}` : `new Intl.PluralRules(${x(e)}).select(+${t}) === ${x(r)}`;
}
function de(e) {
  let t = JSON.stringify(e, xe);
  return t = t.replace(/("__qsOpenBt)|(__qsCloseBt")/g, "`"), t;
}
function xe(e, t) {
  return typeof t == "string" && /^`.*`$/.test(t) ? t.replace(/^`/, "__qsOpenBt").replace(/`$/, "__qsCloseBt") : t;
}
export {
  Ie as qwikSpeakInline
};
